with Ada.Sequential_IO;
with Interfaces; use Interfaces;

package Shardware is

  type Byte is mod 256;
  package Bin_IO is new Ada.Sequential_IO (Byte);
  type ByteArr is array (Integer range <>) of Byte;

  type RegArrI is array (Integer range <>) of Integer;
  type RegArrF is array (Integer range <>) of Float;
  type RegArrU is array (Integer range <>) of Unsigned_32;

  function My_ShiftI (Value : Byte; Amount : Integer) return Integer;
  function My_ShiftF (Value : Byte; Amount : Integer) return Float;
  function My_ShiftU (Value : Byte; Amount : Integer) return Unsigned_32;

  function Bytes_To_I (Instruction : ByteArr) return Integer;
  function Bytes_To_U (Instruction : ByteArr) return Unsigned_32;

  procedure MovI (Register : in out Integer; Value : Integer);
  procedure AddI (Register : in out Integer; Value : Integer);
  procedure MovF (Register : in out Float; Value : Float);
  procedure AddF (Register : in out Float; Value : Float);
  procedure MovU (Register : in out Unsigned_32; Value : Unsigned_32);
  procedure AddU (Register : in out Unsigned_32; Value : Unsigned_32);

end Shardware;
